Index: java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Registry.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/Registry.java	(revision 88)
@@ -4,9 +4,7 @@
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.DoubleMap;
+import com.framsticks.util.FramsticksException;
 
-import java.util.Collections;
-import java.util.HashMap;
-import java.util.HashSet;
-import java.util.Map;
 import java.util.Set;
 
@@ -16,47 +14,4 @@
 public class Registry {
 	private static final Logger log = Logger.getLogger(Registry.class.getName());
-
-	public static class DoubleSet<K1, K2, V> {
-		protected final Map<K1, V> byId = new HashMap<>();
-		protected final Map<K2, V> byName = new HashMap<>();
-		protected final Set<V> values = new HashSet<>();
-
-		public int size() {
-			return values.size();
-		}
-
-		public void put(K1 id, K2 name, V value) {
-			values.add(value);
-			if (id != null) {
-				byId.put(id, value);
-			}
-			if (name != null) {
-				byName.put(name, value);
-			}
-		}
-
-		public boolean containsValue(V value) {
-			return values.contains(value);
-
-		}
-
-		public boolean containsKey(String identifier) {
-			return byId.containsKey(identifier) || byName.containsKey(identifier);
-		}
-
-		public V get(String identifier) {
-			if (byId.containsKey(identifier)) {
-				return byId.get(identifier);
-			}
-			if (byName.containsKey(identifier)) {
-				return byName.get(identifier);
-			}
-			return null;
-		}
-
-		public Set<V> getValues() {
-			return Collections.unmodifiableSet(values);
-		}
-	}
 
 	// protected void internalRegisterClass(FramsClass framsClass, @Nullable Class<?> javaClass) {
@@ -71,6 +26,6 @@
 	// 	}
 	// }
-	protected final DoubleSet<String, String, Class<?>> javaClasses = new DoubleSet<>();
-	protected final DoubleSet<String, String, FramsClass> framsClasses = new DoubleSet<>();
+	protected final DoubleMap<String, Class<?>> javaClasses = new DoubleMap<>();
+	protected final DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
 
 	public void registerReflectedClass(String name, String id, Class<?> reflectedClass) {
@@ -78,18 +33,22 @@
 	}
 
+	public Registry registerAndBuild(Class<?> reflectedClass) {
+		register(reflectedClass);
+		putInfoIntoCache(FramsClass.build().forClass(reflectedClass));
+		return this;
+	}
+
 	public Registry register(Class<?> reflectedClass) {
 		FramsClassAnnotation a = reflectedClass.getAnnotation(FramsClassAnnotation.class);
 		if (a == null) {
-			log.error("class is not annotated: " + reflectedClass);
-			return this;
+			throw new FramsticksException().msg("class is not annotated").arg("class", reflectedClass);
 		}
 
 		registerReflectedClass(FramsClassBuilder.getName(a, reflectedClass), FramsClassBuilder.getId(a, reflectedClass), reflectedClass);
-
 		return this;
 	}
 
 	public AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
-		assert framsClasses.containsValue(framsClass);
+		// assert framsClasses.containsValue(framsClass);
 		if (javaClasses.containsKey(name)) {
 			return new ReflectionAccess(javaClasses.get(name), framsClass);
Index: java/main/src/main/java/com/framsticks/params/types/BooleanParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 88)
@@ -20,5 +20,5 @@
 	 */
 	public BooleanParam(ParamBuilder builder) {
-		super(builder.defaultDef(false));
+		super(builder.fillDef(false).fillStorageType(Boolean.class));
 	}
 
Index: java/main/src/main/java/com/framsticks/params/types/DecimalParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 88)
@@ -17,5 +17,5 @@
 	 */
 	public DecimalParam(ParamBuilder builder) {
-		super(builder.defaultDef(0));
+		super(builder.fillDef(0).fillStorageType(Integer.class));
 	}
 
Index: java/main/src/main/java/com/framsticks/params/types/FloatParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 88)
@@ -17,5 +17,5 @@
 	 */
 	public FloatParam(ParamBuilder builder) {
-		super(builder.defaultDef(0.0));
+		super(builder.fillDef(0.0).fillStorageType(Double.class));
 	}
 
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 88)
@@ -11,4 +11,6 @@
 
 import com.framsticks.model.Model;
+import com.framsticks.model.f0.Schema;
+
 import static com.framsticks.params.SimpleAbstractAccess.*;
 
@@ -49,5 +51,5 @@
 			Pair<String, String> p = Strings.splitIntoPair(line, ':', "");
 			String classId = p.first.trim();
-			FramsClass framsClass = schema.getRegistry().getInfoFromCache(classId);
+			FramsClass framsClass = schema.getFramsClass(classId);
 			if (framsClass == null) {
 				throw new Exception("unknown class id: " + classId);
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 88)
@@ -2,4 +2,5 @@
 
 import com.framsticks.model.Model;
+import com.framsticks.model.f0.Schema;
 import com.framsticks.params.*;
 import com.framsticks.util.Misc;
Index: java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 88)
@@ -1,3 +1,5 @@
 package com.framsticks.parsers;
+
+import javax.annotation.Nonnull;
 
 import com.framsticks.params.*;
@@ -11,5 +13,5 @@
 	// private static final Logger log = Logger.getLogger(Loaders.class.getName());
 
-	public static FramsClass loadFramsClass(SourceInterface source) throws ConstructionException {
+	public static @Nonnull FramsClass loadFramsClass(SourceInterface source) throws ConstructionException {
 		final MultiParamLoader loader = new MultiParamLoader();
 		loader.setNewSource(source);
Index: java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 88)
@@ -43,5 +43,5 @@
 	protected AccessInterface lastAccessInterface;
 
-	protected static FramsClass emptyFramsClass = FramsClass.build().idAndName("<empty>").finish();
+	protected static final FramsClass emptyFramsClass = FramsClass.build().idAndName("<empty>").finish();
 	/**
 	 * Empty Param representing unknown classes - used to omit unknown
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 88)
@@ -1,5 +1,124 @@
 package com.framsticks.parsers;
 
+import java.io.InputStream;
+
+import javax.xml.parsers.DocumentBuilder;
+import javax.xml.parsers.DocumentBuilderFactory;
+
+import org.apache.log4j.Logger;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NamedNodeMap;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Registry;
+import com.framsticks.util.FramsticksException;
+
 public class XmlLoader {
+	private static final Logger log = Logger.getLogger(XmlLoader.class);
 
+	protected Registry registry = new Registry();
+
+	/**
+	 *
+	 */
+	public XmlLoader() {
+	}
+
+	/**
+	 * @return the registry
+	 */
+	public Registry getRegistry() {
+		return registry;
+	}
+
+	boolean useLowerCase = false;
+
+	/**
+	 * @param useLowerCase the useLowerCase to set
+	 */
+	public void setUseLowerCase(boolean useLowerCase) {
+		this.useLowerCase = useLowerCase;
+	}
+
+	public Object processElement(Element element) {
+		String name = element.getNodeName();
+		if (useLowerCase) {
+			name = name.toLowerCase();
+		}
+		if (name.equals("import")) {
+			String className = element.getAttribute("class");
+			try {
+				registry.registerAndBuild(Class.forName(className));
+				return null;
+			} catch (ClassNotFoundException e) {
+				throw new FramsticksException().msg("failed to import class").arg("name", name).cause(e);
+			}
+		}
+
+		AccessInterface access = registry.createAccess(name);
+
+		if (access == null) {
+			throw new FramsticksException().msg("failed to find access interface").arg("name", name);
+		}
+		Object object = access.createAccessee();
+		assert object != null;
+		access.select(object);
+
+		NamedNodeMap attributes = element.getAttributes();
+		for (int i = 0; i < attributes.getLength(); ++i) {
+			Node attributeNode = attributes.item(i);
+			access.set(attributeNode.getNodeName().toLowerCase(), attributeNode.getNodeValue());
+		}
+
+		NodeList children = element.getChildNodes();
+		log.debug("found " + children.getLength() + " children in " + object);
+		for (int i = 0; i < children.getLength(); ++i) {
+			Node childNode = children.item(i);
+			if (!(childNode instanceof Element)) {
+				continue;
+			}
+			Object childObject = processElement((Element) childNode);
+			if (childObject == null) {
+				continue;
+			}
+
+			if (!access.tryAutoAppend(childObject)) {
+				throw new FramsticksException().msg("failed to auto append").arg("child", childObject).arg("parent", object);
+			}
+		}
+		log.debug("loaded " + object);
+
+		return object;
+	}
+
+	public Object load(InputStream stream) {
+		try {
+			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
+			DocumentBuilder db = factory.newDocumentBuilder();
+
+			Document document = db.parse(stream);
+			document.getDocumentElement().normalize();
+			Element element = document.getDocumentElement();
+			assert element != null;
+
+			return processElement(element);
+
+		} catch (Exception e) {
+			throw new FramsticksException().msg("failed to load").cause(e);
+		}
+	}
+
+	public <T> T load(InputStream stream, Class<T> type) {
+		registry.registerAndBuild(type);
+
+		Object object = load(stream);
+		if (type.isAssignableFrom(object.getClass())) {
+			return type.cast(object);
+		}
+		throw new FramsticksException().msg("invalid type has been loaded");
+	}
 }
+
Index: java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 88)
@@ -1,8 +1,16 @@
 package com.framsticks.portals;
 
-import com.framsticks.observers.Observer;
+
+import com.framsticks.core.AbstractInstanceListener;
+import com.framsticks.core.Instance;
+import com.framsticks.core.Path;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.PeriodicTask;
+import com.framsticks.util.Logging;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.RunAt;
+
 import org.apache.log4j.Logger;
 
@@ -12,5 +20,5 @@
  */
 @FramsClassAnnotation
-public class Portal extends Observer {
+public class Portal extends JoinableCollection<Instance> {
 
 	private final static Logger log = Logger.getLogger(Portal.class.getName());
@@ -22,21 +30,45 @@
 	}
 
-	@Override
-	public void run() {
-		super.run();
-		new PeriodicTask<Portal>(this, 1000) {
+	// @Override
+	// public void run() {
+	// 	super.run();
+	// 	new PeriodicTask<Portal>(this, 1000) {
 
-			@Override
-			public void run() {
-				++counter;
-				log.debug("counter is now: " + counter);
-				again();
-			}
-		};
-	}
+	// 		@Override
+	// 		public void run() {
+	// 			++counter;
+	// 			log.debug("counter is now: " + counter);
+	// 			again();
+	// 		}
+	// 	};
+	// }
 
 	@Override
-	protected PortalEndpoint createEndpoint() {
-		return new PortalEndpoint();
+	public void add(final Instance instance) {
+		super.add(instance);
+		instance.addListener(new AbstractInstanceListener() {
+			@Override
+			public void onRun(Exception e) {
+				assert Dispatching.isThreadSafe();
+
+				super.onRun(e);
+
+				if (e != null) {
+					return;
+				}
+				final String path = "/simulator/genepools/groups/0/genotypes";
+				instance.invokeLater(new RunAt<Instance>() {
+					@Override
+					public void run() {
+						instance.resolve(path, new Future<Path>() {
+							@Override
+							public void result(Path result, Exception e) {
+								Logging.log(log, "resolve", path, e);
+							}
+						});
+					}
+				});
+			}
+		});
 	}
 
Index: java/main/src/main/java/com/framsticks/remote/RemoteInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 88)
@@ -9,4 +9,6 @@
 import com.framsticks.core.Path;
 import com.framsticks.params.*;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.parsers.MultiParamLoader;
@@ -15,17 +17,20 @@
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.dispatching.RunAt;
 
-import org.apache.commons.configuration.Configuration;
+import java.util.*;
+
 import org.apache.log4j.Logger;
-
-import java.util.*;
 
 /**
  * @author Piotr Sniegowski
  */
-public class RemoteInstance extends Instance {
+@FramsClassAnnotation
+public class RemoteInstance extends Instance implements JoinableParent {
 
 	private final static Logger log = Logger.getLogger(RemoteInstance.class.getName());
@@ -45,9 +50,20 @@
 	}
 
-	@Override
-	public void run() {
-		assert isActive();
-		super.run();
-		connection.connect(new StateFunctor() {
+	public RemoteInstance() {
+	}
+
+	@ParamAnnotation
+	public void setAddress(String address) {
+		setConnection(new ClientConnection(address));
+	}
+
+	@ParamAnnotation
+	public String getAddress() {
+		return connection == null ? "<disconnected>" : connection.getAddress();
+	}
+
+	public void setConnection(final ClientConnection connection) {
+		this.connection = connection;
+		this.connection.setConnectedFunctor(new StateFunctor() {
 			@Override
 			public void call(Exception e) {
@@ -60,8 +76,6 @@
 					public void call(Exception e) {
 						if (e != null) {
-							log.fatal("unsupported protocol version!\n minimal version is: "
-									+ "nmanager protocol is: "
-									+ connection.getProtocolVersion());
-							connection.close();
+							log.fatal("unsupported protocol version!\n minimal version is: " + "\nmanager protocol is: " + connection.getProtocolVersion());
+							Dispatching.drop(connection, RemoteInstance.this);
 							fireRun(e);
 							return;
@@ -112,22 +126,5 @@
 			}
 		});
-	}
-
-	public RemoteInstance() {
-	}
-
-
-	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
-		connection = new ClientConnection(config.getString("address"));
-	}
-
-	public void setAddress(String address) {
-		setConnection(new ClientConnection(address));
-	}
-
-	public void setConnection(ClientConnection connection) {
-		this.connection = connection;
+
 	}
 
@@ -135,5 +132,5 @@
 	public String toString() {
 		assert Dispatching.isThreadSafe();
-		return getConnection().getAddress();
+		return "remote instance " + getName() + "(" + getAddress() + ")";
 	}
 
@@ -167,5 +164,5 @@
 			}
 		});
-		*/
+		 */
 	}
 
@@ -175,10 +172,10 @@
 	}
 
-	public void disconnect() {
-		assert isActive();
-		if (connection.isConnected()) {
-			connection.close();
-		}
-	}
+	// public void disconnect() {
+	//	assert isActive();
+	//	if (connection.isConnected()) {
+	//		Dispatching.stop(connection, this);
+	//	}
+	// }
 
 	public final ClientConnection getConnection() {
@@ -247,11 +244,13 @@
 				assert response.getFiles().size() == 1;
 				assert path.isTheSame(response.getFiles().get(0).getPath());
-				FramsClass framsClass = processFetchedInfo(response.getFiles().get(0));
-
-				if (framsClass == null) {
+				FramsClass framsClass;
+				try {
+					framsClass = processFetchedInfo(response.getFiles().get(0));
+				} catch (ConstructionException e) {
 					log.fatal("could not read class info");
 					finishInfoRequest(name, null, new Exception("could not read class info"));
 					return;
 				}
+
 				CompositeParam thisParam = path.getTop().getParam();
 				if (!thisParam.isMatchingContainedName(framsClass.getId())) {
@@ -335,13 +334,15 @@
 		}
 
-
 		assert path.size() >= 2;
 		FramsClass underFramsClass = getInfoFromCache(path.getUnder().getParam().getContainedTypeName());
 
-		EventParam changedEvent = underFramsClass.getParamEntry(path.getTop().getParam().getId() + "_changed", EventParam.class);
-		if (changedEvent == null) {
+		EventParam changedEvent;
+		try {
+			changedEvent = underFramsClass.getParamEntry(path.getTop().getParam().getId() + "_changed", EventParam.class);
+		} catch (FramsticksException e) {
 			return;
 		}
 
+		log.debug("registering for " + changedEvent);
 		if (getSubscription(path) != null) {
 			return;
@@ -394,5 +395,4 @@
 	}
 
-
 	protected void reactToChange(final Path path, final ListChange listChange) {
 		assert isActive();
@@ -416,42 +416,41 @@
 		}
 
-
 		CompositeParam childParam = Casting.tryCast(CompositeParam.class, access.getParam(listChange.getBestIdentifier()));
 		assert childParam != null;
 		switch (listChange.getAction()) {
-			case Add: {
-				final String p = path.getTextual() + "/" + childParam.getId();
-				resolveAndFetch(p, new Future<Path>() {
-					@Override
-					public void result(Path result, Exception e) {
-						if (e != null) {
-							log.error("failed to add " + p + ": " + e);
-							return;
-						}
-						log.debug("added: " + result);
-						fireListChange(path, listChange);
-					}
-				});
-				break;
-			}
-			case Remove: {
-				access.set(childParam, null);
-				fireListChange(path, listChange);
-				break;
-			}
-			case Modify: {
-				final String p = path.getTextual() + "/" + childParam.getId();
-				resolveAndFetch(p, new Future<Path>() {
-					@Override
-					public void result(Path result, Exception e) {
-						if (e != null) {
-							log.error("failed to modify " + p + ": " + e);
-							return;
-						}
-						fireListChange(path, listChange);
-					}
-				});
-				break;
-			}
+		case Add: {
+			final String p = path.getTextual() + "/" + childParam.getId();
+			resolveAndFetch(p, new Future<Path>() {
+				@Override
+				public void result(Path result, Exception e) {
+					if (e != null) {
+						log.error("failed to add " + p + ": " + e);
+						return;
+					}
+					log.debug("added: " + result);
+					fireListChange(path, listChange);
+				}
+			});
+			break;
+		}
+		case Remove: {
+			access.set(childParam, null);
+			fireListChange(path, listChange);
+			break;
+		}
+		case Modify: {
+			final String p = path.getTextual() + "/" + childParam.getId();
+			resolveAndFetch(p, new Future<Path>() {
+				@Override
+				public void result(Path result, Exception e) {
+					if (e != null) {
+						log.error("failed to modify " + p + ": " + e);
+						return;
+					}
+					fireListChange(path, listChange);
+				}
+			});
+			break;
+		}
 		}
 	}
@@ -473,3 +472,35 @@
 		});
 	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(connection, this);
+		super.joinableStart();
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(connection, this);
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+
+	}
+
+	@Override
+	public void joinableJoin() throws InterruptedException {
+		Dispatching.join(connection);
+		super.joinableJoin();
+	}
+
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+
 }
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 88)
@@ -0,0 +1,146 @@
+package com.framsticks.running;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.io.OutputStreamWriter;
+import java.io.PrintWriter;
+import java.util.ArrayList;
+import java.util.LinkedList;
+import java.util.List;
+
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Entity;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
+import com.framsticks.util.dispatching.Thread;
+import com.framsticks.util.io.Encoding;
+
+@FramsClassAnnotation
+public class ExternalProcess extends Thread<ExternalProcess> implements Entity {
+	private static final Logger log = Logger.getLogger(ExternalProcess.class);
+
+	protected List<String> arguments = new ArrayList<>();
+	protected Process process;
+	protected ProcessBuilder builder = new ProcessBuilder();
+	protected Thread<ExternalProcess> readerThread;
+
+	protected PrintWriter input;
+	protected BufferedReader output;
+	protected Integer exitCode;
+
+	protected final List<OutputListener> listeners = new LinkedList<>();
+
+	public void addListener(OutputListener listener) {
+		synchronized (listeners) {
+			listeners.add(listener);
+		}
+	}
+
+	/**
+	 *
+	 */
+	public ExternalProcess() {
+		super();
+		setName("process");
+		arguments.add(null);
+	}
+
+	/**
+	 * @return the command
+	 */
+	@ParamAnnotation
+	public String getCommand() {
+		return arguments.get(0);
+	}
+
+	/**
+	 * @param command the command to set
+	 */
+	@ParamAnnotation
+	public void setCommand(String command) {
+		arguments.set(0, command);
+	}
+
+	@Override
+	protected void routine() {
+
+		String line;
+		try {
+			try {
+				while ((line = output.readLine()) != null) {
+					log.trace("read line: " + line);
+					synchronized (listeners) {
+						for (OutputListener l : listeners) {
+							l.onLineRead(line);
+						}
+					}
+				}
+			} catch (IOException e) {
+				throw new FramsticksException().msg("failed to read line from output of process").cause(e);
+			}
+			try {
+				exitCode = process.waitFor();
+			} catch (InterruptedException e) {
+				throw new FramsticksException().msg("failed to wait for process").cause(e);
+			}
+			log.debug("process ended " + this);
+			process = null;
+		} catch (FramsticksException e) {
+			log.error("exception caught in process " + this, e);
+		}
+		interrupt();
+	}
+
+
+
+	@ParamAnnotation
+	public void setDirectory(String directory) {
+		builder.directory(new File(directory));
+	}
+
+	@ParamAnnotation
+	public String getDirectory() {
+		return builder.directory().getName();
+	}
+
+	@Override
+	public void joinableStart() {
+		builder = new ProcessBuilder();
+		log.debug("running process with arguments: " + arguments);
+		builder.command(arguments);
+		try {
+			process = builder.start();
+			input = new PrintWriter(new OutputStreamWriter(process.getOutputStream(), Encoding.getDefaultCharset()));
+			output = new BufferedReader(new InputStreamReader(process.getInputStream(), Encoding.getDefaultCharset()));
+		} catch (IOException e) {
+			throw new FramsticksException().msg("failed to start process").cause(e);
+		}
+		super.joinableStart();
+
+	}
+
+	@Override
+	public String toString() {
+		return super.toString() + "[" + Misc.returnNotNull(getCommand(), "?") + "]";
+	}
+
+	/**
+	 * @return the input
+	 */
+	public PrintWriter getInput() {
+		return input;
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		super.joinableInterrupt();
+		finish();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/running/FramsServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 88)
@@ -0,0 +1,45 @@
+package com.framsticks.running;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class FramsServer extends ExternalProcess {
+
+	protected Integer port;
+
+	/**
+	 *
+	 */
+	public FramsServer() {
+		super();
+		setCommand("/home/psniegowski/mgr/Framsticks32rc5/frams.linux");
+		setDirectory("/home/psniegowski/mgr/Framsticks32rc5");
+		setName("frams");
+	}
+
+	/**
+	 * @return the port
+	 */
+	@ParamAnnotation
+	public Integer getPort() {
+		return port;
+	}
+
+	/**
+	 * @param port the port to set
+	 */
+	@ParamAnnotation
+	public void setPort(Integer port) {
+		this.port = port;
+	}
+
+	@Override
+	public void joinableStart() {
+		if (port != null) {
+			arguments.add("-p" + port);
+		}
+		super.joinableStart();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/running/OutputListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/OutputListener.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/running/OutputListener.java	(revision 88)
@@ -0,0 +1,5 @@
+package com.framsticks.running;
+
+public interface OutputListener {
+	void onLineRead(String line);
+}
Index: java/main/src/main/java/com/framsticks/util/Builder.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Builder.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/Builder.java	(revision 88)
@@ -0,0 +1,7 @@
+package com.framsticks.util;
+
+public interface Builder<T> {
+
+	public T finish();
+
+}
Index: java/main/src/main/java/com/framsticks/util/DoubleMap.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/DoubleMap.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/DoubleMap.java	(revision 88)
@@ -0,0 +1,52 @@
+package com.framsticks.util;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+
+public class DoubleMap<K, V> {
+
+	protected final Map<K, V> byId = new HashMap<>();
+	protected final Map<K, V> byName = new HashMap<>();
+	protected final Set<V> values = new HashSet<>();
+
+	public int size() {
+		return values.size();
+	}
+
+	public void put(K id, K name, V value) {
+		values.add(value);
+		if (id != null) {
+			byId.put(id, value);
+		}
+		if (name != null) {
+			byName.put(name, value);
+		}
+	}
+
+	public boolean containsValue(V value) {
+		return values.contains(value);
+
+	}
+
+	public boolean containsKey(K identifier) {
+		return byId.containsKey(identifier) || byName.containsKey(identifier);
+	}
+
+	public V get(K identifier) {
+		if (byId.containsKey(identifier)) {
+			return byId.get(identifier);
+		}
+		if (byName.containsKey(identifier)) {
+			return byName.get(identifier);
+		}
+		return null;
+	}
+
+	public Set<V> getValues() {
+		return Collections.unmodifiableSet(values);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/FramsticksException.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 88)
@@ -50,6 +50,6 @@
 			b.append("(").append(d.build()).append(")");
 		}
-		if (this.getCause() instanceof FramsticksException) {
-			b.append(" caused by ").append(this.getCause().getMessage());
+		if (this.getCause() != null) {
+			b.append(" caused by: [").append(this.getCause().getMessage()).append("]");
 		}
 		return b.toString();
Index: java/main/src/main/java/com/framsticks/util/Misc.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Misc.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/util/Misc.java	(revision 88)
@@ -1,3 +1,5 @@
 package com.framsticks.util;
+
+// import org.apache.log4j.Logger;
 
 /**
@@ -5,5 +7,32 @@
  */
 public class Misc {
+	// private static final Logger log =
+	// 	Logger.getLogger(Misc.class);
+
+	public static class WithType {
+		protected Object value;
+
+		/**
+		 * @param value
+		 */
+		public WithType(Object value) {
+			this.value = value;
+		}
+
+		@Override
+		public String toString() {
+			if (value == null) {
+				return "null";
+			}
+			return value + "(" + value.getClass() + ")";
+		}
+	}
+
+	public static WithType withType(Object value) {
+		return new WithType(value);
+	}
+
 	public static boolean equals(Object a, Object b) {
+		// log.info("equality of " + withType(a) + " ? " + withType(b));
 		if (a != null) {
 			return (b != null && a.equals(b));
@@ -11,3 +40,17 @@
 		return b == null;
 	}
+
+	public static <T> T returnNotNull(T first, T second) {
+		if (first != null) {
+			return first;
+		}
+		return second;
+	}
+
+	public static <T> T throwIfNull(T value) {
+		if (value == null) {
+			throw new FramsticksException().msg("value should not be null");
+		}
+		return value;
+	}
 }
